#Building ZyprJavaGUI
Zypr Reference Client Java Implementation ("[ZyprJavaGUI][1]") utilizes [Apache Ant™][2] as a distribution management and packaging tool. Version 1.8.2 or above is recommended. 
And [Oracle JDK][3] / [OpenJDK][4] version 1.5 or above is required in order to compile the Java source code.

##Library Dependencies
ZyprJavaGUI depends on the following external libraries:

* [Apache HttpComponents HttpCore][5]
* [Apache HttpComponents HttpClient][6]
* [Apache HttpComponents HttpMime][7]
* [Apache Commons Logging][8]
* [Apache Commons Codec][9]
* [Apache James Mime4j][10]
* [JSON.simple][11]
* [SwingX Core][12]
* [SwingX BeanInfo][12]
* [Zypr API Access Java Library][13]

For your convenience we have included these libraries into repository in [Zypr-Reference-Client---Java/tree/master/libraries][14]

##Build Instructions

**1 -** Clone the ZyprJavaGUI repository into a new directory

    git clone https://github.com/Zypr/Zypr-Reference-Client---Java.git
    
![Step 1 Screen Shot](http://zypr.github.com/Zypr-API-Access-Library---Java/screen-shots/java-gui-1.png)

**2 -** Change the current working directory to ZyprJavaGUI repository directory

    cd Zypr-Reference-Client---Java
    
![Step 2 Screen Shot](http://zypr.github.com/Zypr-API-Access-Library---Java/screen-shots/java-gui-2.png)

**3 -** Open [Application.java][15] with your favorite editor, uncomment the line below

    System.setProperty("net.zypr.api.key", "REPLACE THIS WITH YOUR API KEY");

![Step 3 Screen Shot](http://zypr.github.com/Zypr-API-Access-Library---Java/screen-shots/java-gui-3.png)

Replace the text _"REPLACE THIS WITH YOUR API KEY"_ with the API key you have got from [http://developer.zypr.net][16]

If you do not have any API keys already, please check out [APIKEY.md][17] for detailed instructions to get one.

![Step 4 Screen Shot](http://zypr.github.com/Zypr-API-Access-Library---Java/screen-shots/java-gui-4.png)

Save the [Application.java][15] file.

**4 -** Compile ZyprJavaGUI project using ant make tool

    ant
    
![Step 5 Screen Shot](http://zypr.github.com/Zypr-API-Access-Library---Java/screen-shots/java-gui-5.png)

When the compilation is completed successfully, you should see new a Jar file in [Zypr-API-Access-Library---Java/release][18]

![Step 6 Screen Shot](http://zypr.github.com/Zypr-API-Access-Library---Java/screen-shots/java-gui-6.png)

_optional step :_ You may clean the working directory by typing;

    ant clean

##Running ZyprJavaGUI

After completing the step above, to run the ZyprJavaGUI simply type;

    java -cp ./libraries/ -jar zypr-gui-rXXXXXXXX.jar

![Step 7 Screen Shot](http://zypr.github.com/Zypr-API-Access-Library---Java/screen-shots/java-gui-7.png)

[1]: http://git.io/ZyprJavaGUI
[2]: http://ant.apache.org/
[3]: http://www.oracle.com/technetwork/java/index.html
[4]: http://openjdk.java.net/
[5]: http://hc.apache.org/httpcomponents-core-ga/
[6]: http://hc.apache.org/httpcomponents-client-ga/
[7]: http://hc.apache.org/httpcomponents-client-ga/httpmime/
[8]: http://commons.apache.org/logging/
[9]: http://commons.apache.org/codec/
[10]: http://james.apache.org/mime4j/
[11]: http://code.google.com/p/json-simple/
[12]: http://swingx.java.net/
[13]: https://github.com/Zypr/Zypr-API-Access-Library---Java/tree/master/release
[14]: https://github.com/Zypr/Zypr-Reference-Client---Java/tree/master/libraries
[15]: https://github.com/Zypr/Zypr-Reference-Client---Java/blob/master/source/net/zypr/gui/Application.java
[16]: http://developer.zypr.net
[17]: https://github.com/Zypr/Zypr-Reference-Client---Java/blob/master/APIKEY.md
[18]: https://github.com/Zypr/Zypr-Reference-Client---Java/tree/master/release