/**
 *
 * Initial version of this code (c) 2009-2011 Media Tuners LLC with a full license to Pioneer Corporation.
 *
 * Pioneer Corporation licenses this file to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and limitations under the License.
 *
 */

package net.zypr.gui.components;

import java.awt.Color;
import java.awt.Font;

import javax.swing.JTextPane;
import javax.swing.text.StyledDocument;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TextPane
        extends JTextPane
{
    protected final Logger _logger = LoggerFactory.getLogger(getClass().getCanonicalName());

    public TextPane(StyledDocument styledDocument)
    {
        super(styledDocument);
        jbInit();
    }

    public TextPane()
    {
        super();
        jbInit();
    }

    protected void jbInit()
    {
        setOpaque(false);
        setEditable(true);
        setForeground(Color.WHITE);
        setFont(new Font("Dialog", 1, 16));
        setContentType("text/plain");
        setCaretColor(Color.LIGHT_GRAY);
    }
}
