/**
 *
 * Initial version of this code (c) 2009-2011 Media Tuners LLC with a full license to Pioneer Corporation.
 *
 * Pioneer Corporation licenses this file to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and limitations under the License.
 *
 */

package net.zypr.gui.windows;

import net.miginfocom.swing.MigLayout;
import net.zypr.api.API;
import net.zypr.api.vo.InfoIncidentTypeVO;
import net.zypr.api.vo.ItemVO;
import net.zypr.gui.ImageFetcher;
import net.zypr.gui.components.ImagePanel;
import net.zypr.gui.components.Label;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;

public class TrafficDetailsWindow extends ModalWindow
{
    private ItemVO _trafficItemVO = null;
    private ImagePanel imagePanelPicture = new ImagePanel("placeholder-picture-poi-96.png");
    private Label descriptionLabel = new Label();

    public TrafficDetailsWindow(ItemVO itemVO)
    {
        try {
            _trafficItemVO = itemVO;
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception
    {
        this.setSize(new Dimension(560, 180));
        setTitle("Traffic Event Details");
        // TODO: make non-blocking?
        BufferedImage serviceIcon = ImageFetcher.getInstance().getImage(API.getInstance().getNav().getService(_trafficItemVO.getService()).getServiceIconURI());
        setTitleImage(serviceIcon);

        MigLayout layout = new MigLayout("ins 5");
        _panelContent.setLayout(layout);
        _panelContent.add(imagePanelPicture, "width 96!");
        _panelContent.add(descriptionLabel, "width 440!");

        InfoIncidentTypeVO details = (InfoIncidentTypeVO)_trafficItemVO.getInfo();
        if (details != null) {
            descriptionLabel.setText(details.getDescription());
        }
        descriptionLabel.setHorizontalAlignment(SwingConstants.LEFT);
        descriptionLabel.setFont(new Font("Dialog",Font.PLAIN,18));
        descriptionLabel.setLineWrap(true);

        /*
        new Thread(new Runnable()
        {
            public void run()
            {
                ItemVO detailsItemVO = null;
                try {
                    detailsItemVO = API.getInstance().getNav().incidentDetails(_TrafficItemVO.getService(), _TrafficItemVO.getServiceItemID());

                    descriptionLabel.setText(detailsItemVO.getDescription());
                    descriptionLabel.setHorizontalAlignment(SwingConstants.LEFT);
                    descriptionLabel.setFont(new Font("Dialog",Font.PLAIN,18));
                    descriptionLabel.setLineWrap(true);
                } catch (Exception exception) {
                    _logger.error("", exception);
                }
            }
        }).start();
        */

        //ItemVO details = API.getInstance().getNav().incidentDetails(_TrafficItemVO.getService(), _TrafficItemVO.getServiceItemID());
    }

    protected void _buttonWindowClose_actionPerformed(ActionEvent actionEvent)
    {
        getParentPanel().discardWindow();
    }

}
